/*
 * Copyright (C) 2012 Martin Owens <doctormo@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
 * USA.
 *
 * Authors:
 *      Martin Owens <doctormo@gmail.com>
 */

public class DeviantArtPlugin : Ap.OAuthPlugin {
    public DeviantArtPlugin (Ag.Account account) {
        Object (account: account);
    }

    construct
    {
        var oauth_params = new HashTable<string, GLib.Value?> (str_hash, null);
        oauth_params.insert ("Host", "www.deviantart.com");
        oauth_params.insert ("AuthPath",  "oauth2/draft15/authorize");
        oauth_params.insert ("TokenPath", "oauth2/draft15/token");
        oauth_params.insert ("RedirectUri", "https://wiki.ubuntu.com/");
        oauth_params.insert ("ClientId", "20");
        oauth_params.insert ("ClientSecret", "bfcf5ceafa3bb291ca313cbf7ced7c9e");
        //oauth_params.insert ("ResponseType", "token");
        oauth_params.insert ("ResponseType", "code");

        /*string[] scopes = {
            "stash",
            "user"
        };*/
        //oauth_params.insert ("Scope", scopes);
        set_oauth_parameters (oauth_params);
        set_mechanism(Ap.OAuthMechanism.WEB_SERVER);
    }
}

public GLib.Type ap_module_get_object_type ()
{
    return typeof (DeviantArtPlugin);
}
